//A complex.
n=20; 
A=rand(n,n)+%i*rand(n,n);
MATA=sparse(A);
which='LM';amode='Z1';nv=6;
[Z ,vasp]=spec(A);vasp=diag(vasp);
[va,ve]=eigen(nv,amode,which,MATA.' );
max(abs(A*ve(:,1)-ve(:,1)*  va(1)))
max(abs(A* Z(:,1)- Z(:,1)*vasp(1)))
[vat,ps]=sort(real(vasp));
[vat,pe]=sort(real(va  ));
[vasp(ps(1:size(va,1))) va(pe)]

//A real.
n=20; 
A=rand(n,n);
MATA=sparse(A);
which='LM';amode='R1';nv=6;
[Z ,vasp]=spec(A);vasp=diag(vasp);
[va,ve]=eigen(nv,amode,which,MATA.' );
max(abs(A*ve(:,1)-ve(:,1)*  va(1)))
max(abs(A* Z(:,1)- Z(:,1)*vasp(1)))

[vat,ps]=sort(real(vasp));
[vat,pe]=sort(real(va  ));
[vasp(ps(1:size(va,1))) va(pe)]

//A real and symmetric.
n=20; 
A=rand(n,n);
A=A+A';
MATA=sparse(A);
which='LM';amode='R1';nv=6;
[Z ,vasp]=spec(A);vasp=diag(vasp);
[va,ve]=eigen(nv,amode,which,MATA.' );

max(abs(A*ve(:,1)-ve(:,1)*  va(1)))
max(abs(A* Z(:,1)- Z(:,1)*vasp(1)))

[vat,ps]=sort(real(vasp));
[vat,pe]=sort(real(va  ));
[vasp(ps(1:size(va,1))) va(pe)]

//A and B real.
n=20; 
A=rand(n,n);
B=rand(n,n);
A=A+A';
B=B+B';
sigm=8;
OP=A-sigm*B;
MATOP=sparse(OP);
MATM=sparse(B);
which='LM';amode='R7';nv=6;
[al,be,Q,Z]=spec(A,B);vasp=al./be;
[va,ve]=eigen(nv,amode,which,MATOP.',sigm,MATM.');
max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

[vat,ps]=sort(real(vasp));
[vat,pe]=sort(real(va  ));
[vasp(ps(1:size(va,1))) va(pe)]

//A or B complex.
n=20;
A=rand(n,n)+rand(n,n)*%i;
B=rand(n,n)+rand(n,n)*%i;
sigm=8;
OP=A-sigm*B;
MATOP=sparse(OP);
MATM=sparse(B);
which='LM';amode='Z5';nv=6;
[al,be,Q,Z]=spec(A,B);vasp=al./be;
[va,ve]=eigen(nv,amode,which,MATOP.',sigm,MATM.');
max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

[vat,ps]=sort(real(vasp));
[vat,pe]=sort(real(va  ));
[vasp(ps(1:size(va,1))) va(pe)]

//A and B real, B positive semi-definite
n=20;
A=rand(n,n);
B=rand(n,n);
for i=1:n,B(i,i)=100*B(i,i);,end
if max(imag(spec(B)))== 0 then,
   sigma=8;
   MATOP=sparse(B);
   MATM=sparse(A);
   which='LR';amode='R3';nv=6;
   [al,be,Q,Z]=spec(A,B);vasp=al./be;
   [va,ve]=eigen(nv,amode,which,MATOP.',MATM.');
   max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
   max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

   [vat,ps]=sort(real(vasp));
   [vat,pe]=sort(real(va  ));
   [vasp(ps(1:size(va,1))) va(pe)],
end

//A and B real, B positive semi-definite

n=20;
A=rand(n,n);
B=rand(n,n);
for i=1:n,B(i,i)=100*B(i,i);,end
if max(imag(spec(B)))== 0 then,
   sigm=8;
   MATOP=sparse(A-sigm*B);
   MATM=sparse(B);
   which='LM';amode='R4';nv=6;
   [al,be,Q,Z]=spec(A,B);vasp=al./be;
   [va,ve]=eigen(nv,amode,which,MATOP.',sigm,MATM.');
   max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
   max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

   [vat,ps]=sort(real(vasp));
   [vat,pe]=sort(real(va  ));
   [vasp(ps(1:size(va,1))) va(pe)],
end

//A and B real, symmetric, B positive semi-definite

n=20;
A=rand(n,n);
B=rand(n,n);
A=A+A';B=B+B' ;
for i=1:n,B(i,i)=100*B(i,i);,end
if max(imag(spec(B)))== 0 then,
   sigma=8;
   MATOP=sparse(B);
   MATM=sparse(A);
   which='LM';amode='S3';nv=6;
   [al,be,Q,Z]=spec(A,B);vasp=al./be;
   [va,ve]=eigen(nv,amode,which,MATOP.',MATM.');
   max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
   max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

   [vat,ps]=sort(real(vasp));
   [vat,pe]=sort(real(va  ));
   [vasp(ps(1:size(va,1))) va(pe)],
end

//A and B real, symmetric, B positive semi-definite

n=20;
A=rand(n,n);
B=rand(n,n);
A=A+A';B=B+B' ;
for i=1:n,B(i,i)=100*B(i,i);,end
if max(imag(spec(B)))== 0 then,
   sigm=8;
   MATOP=sparse(A-sigm*B);
   MATM=sparse(B);
   which='LM';amode='S4';nv=6;
   [al,be,Q,Z]=spec(A,B);vasp=al./be;
   [va,ve]=eigen(nv,amode,which,MATOP.',sigm,MATM.');
   max(abs(A*ve(:,1)-B*ve(:,1)*  va(1)))
   max(abs(A* Z(:,1)-B* Z(:,1)*vasp(1)))

   [vat,ps]=sort(real(vasp));
   [vat,pe]=sort(real(va  ));
   [vasp(ps(1:size(va,1))) va(pe)],
end


